# do not modify this file, use conf.sh instead

basedir="/opt/nana"
coredir="$basedir/core"
netldbdir="$basedir/netldb"
logdir="$coredir/log"
rundir="$coredir/run"

# core
user="nana"
golems="dbpipe.sh revisor dispatcher fdb2graph rresolver topology snmp/addresses snmp/agents snmp/dispatcher"

# MySQL
dbhost="nana"
dbname="nana"
dbruser="nanar"
dbrpass="public"
dbwuser="nanaw"
dbwpass="secret"

# for old netldb/usr scripts
mysql_prepinace="-h $dbhost -p$dbrpass -u $dbruser $dbname"

select_opts="-h $dbhost -p$dbrpass -u $dbruser $dbname -Ns"
modify_opts="-h $dbhost -p$dbwpass -u $dbwuser $dbname"

mysqlwpipe="$rundir/mysqlwpipe"

# SNMP
# used for RRD step and heartbeat
# beware - rrdtool tune is needed after changing this variable
# snmpinterval must be <= 1800 because of hardcoded steps in core/snmp/mib/if.sh
snmpinterval=300
# read access
snmprcommunity=public

# RRD
# comment it out, if you do not use rrdcached
rrdcached="--daemon unix:/var/run/rrdcached/rrdcached.sock"

rrddir="$basedir/rrd"
# must be writable by $user above
rrdifdir="$rrddir/if"
rrdstatsdir="$rrddir/stats"

# commands
#digptr="dig +noall +answer -x"

# functions?

# at the very end load the user configuration
# $confdir is set in sourcing script
config=$confdir/conf.sh
test -f $config && . $config
