replace_specchars ()
{
	# avoid mysql injection via string variables
	without_specchars=${1//\'/ }
	# do not cope with a newline
	without_specchars=${without_specchars//$'\n'/ }
	# replace carriage return as well
	without_specchars=${without_specchars//$'\r'/ }
}

is_natural_number ()
{
	test "$1" -ge 0 2>/dev/null
}

is_number ()
{
	test "$1" -ge 0 -o "$1" -lt 0 2>/dev/null
}

create_rrd_gauge ()
{
	local rrdfile=$1
	local rrdstep=$2
	local minimum=$3

	# no big overhead to count this over and over here
	# because rrdtool create is sparse operation
	local rrdheartbeat=$((2 * rrdstep))
	local rraxff=0.5
	local rrathirtym=$((30 * 60 / rrdstep))
	local rratwoh=$((4 * rrathirtym))
	local rraday=$((12 * rratwoh))
	local rraweek=$((7 * rraday))
	local rrarows=600

	# --start is not necessary
	rrdtool create "$rrdfile" --step "$rrdstep" \
		DS:a:GAUGE:$rrdheartbeat:"$minimum":U \
		RRA:AVERAGE:$rraxff:1:$rrarows \
		RRA:AVERAGE:$rraxff:$rrathirtym:$rrarows \
		RRA:AVERAGE:$rraxff:$rratwoh:$rrarows \
		RRA:AVERAGE:$rraxff:$rraday:$rrarows \
		RRA:AVERAGE:$rraxff:$rraweek:$rrarows \
		RRA:MIN:$rraxff:1:$rrarows \
		RRA:MIN:$rraxff:$rrathirtym:$rrarows \
		RRA:MIN:$rraxff:$rratwoh:$rrarows \
		RRA:MIN:$rraxff:$rraday:$rrarows \
		RRA:MIN:$rraxff:$rraweek:$rrarows \
		RRA:MAX:$rraxff:1:$rrarows \
		RRA:MAX:$rraxff:$rrathirtym:$rrarows \
		RRA:MAX:$rraxff:$rratwoh:$rrarows \
		RRA:MAX:$rraxff:$rraday:$rrarows \
		RRA:MAX:$rraxff:$rraweek:$rrarows \
		RRA:LAST:$rraxff:1:$rrarows \
		RRA:LAST:$rraxff:$rrathirtym:$rrarows \
		RRA:LAST:$rraxff:$rratwoh:$rrarows \
		RRA:LAST:$rraxff:$rraday:$rrarows \
		RRA:LAST:$rraxff:$rraweek:$rrarows
}
