#!/bin/bash
# Copyright 2010, 2015 Michal Žejdl
# count sysUpTime from snmpagent - average (days) or sum (years)
# for net-snmp -> NetMRG graph

confdir=$(dirname $0)/..
config=$confdir/defaults.sh
test -f $config || exit
. $config

case "$1" in
average)
	mysql -e "select round(sum(sysUpTime) / (count(*) * 100 * 3600 * 24)) from snmpagent where (exists (select * from snmp4 where status = 0 and agent = id) or exists (select * from snmp6 where status = 0 and agent = id))" $select_opts
	;;
sum)
	mysql -e "select round(sum(sysUpTime) / (100 * 3600 * 24 * 365.25)) from snmpagent where (exists (select * from snmp4 where status = 0 and agent = id) or exists (select * from snmp6 where status = 0 and agent = id))" $select_opts
	;;
*)
	echo "usage: $(basename $0) <average|sum>"
	;;
esac
