#!/bin/bash
# Copyright 2010, 2014, 2015 Michal Žejdl
# stáhne data ze system do pole a pole uloží do tabulky sys

confdir=$(dirname $0)/../../core
config=$confdir/defaults.sh
test -f $config || exit
. $config

prvek=$1

exec 3> $mysqlwpipe

# mohl bych mít na vstupu OIDS, a pak je parsovat do dotazu,
# ale je to O(n) v cyklu, kde n je počet OIDS; takhle jen O(1)
# teď je třeba při přidání OID opravit 4 místa

# while read je nutné, protože IFS=$'\n' pole=($(prikaz)) přeskočí prázdné řádky
# -m SNMPv2-MIB to docela urychlí
# -m '' ještě víc, ale pak nastane peklo s parsováním nechtěných uvozovek
#   je třeba -OE a externí mazač uvozovek (\" -> "" a \\\" -> "\"" pomocí flex)
# číselné OID namísto jmenných už viditelnou úsporu času nepřináší

# přepínače Cisco mají sysDescr.0 přes několik řádek, nenapadlo mě nic lepšího
# než přečíst to naposled; chtělo by to vykoumat co s tím

while read -r; do hodnoty[i++]=$REPLY; done < <(snmpget -v 1 -c public -m SNMPv2-MIB -Oqtv $prvek \
    sysObjectID.0 \
    sysUpTime.0 \
    sysContact.0 \
    sysName.0 \
    sysLocation.0 \
    sysDescr.0 \
    )
# snmpget asi běží v subshell, takže nevím jak zjistit chybu
# řekněme, že stačí, když snmpget vrátil nějakou řádku a pole není prázdné
if test ${#hodnoty[*]} -gt 0; then echo "insert sys (host, \
sysObjectID, \
sysUpTime, \
sysContact, \
sysName, \
sysLocation, \
sysDescr, \
time) values ('$prvek', \
'${hodnoty[0]}', \
'${hodnoty[1]}', \
'${hodnoty[2]}', \
'${hodnoty[3]}', \
'${hodnoty[4]}', \
'${hodnoty[5]}', \
unix_timestamp()) on duplicate key update \
sysObjectID = '${hodnoty[0]}', \
sysUpTime = '${hodnoty[1]}', \
sysContact = '${hodnoty[2]}', \
sysName = '${hodnoty[3]}', \
sysLocation = '${hodnoty[4]}', \
sysDescr = '${hodnoty[5]}', \
time = unix_timestamp();" >&3
fi
