#!/bin/bash
# Michal Žejdl 2009
# vypíše blízké okolí přepínače - ideálně pouze přímo připojená zařízení

. /usr/local/etc/mysql_prepinace

if test "$#" -ne "1"; then
  echo -e "\nJako parametr čekám DNS jméno přepínače."
  echo -e "\nnapříklad:\n"
  echo -e "  $(basename $0) sw4924-inf\n"
  exit
fi

vstup=$1

# dva dotazy spojené pomocí union
# první vybere z fdb mac jen sousedních přepínačů (podle peer a dns)
# druhý vybere z fdb všechny mac, které jsou na portech, kde není soused (peer)
# oba se doplní o dns a společně setřídí
# později změněn druhý join na left join, aby se vypsaly i MAC bez IP
mysql -e "select fdb.port, fdb.mac, checked.dns, from_unixtime(fdb.time) time from fdb join (peer, checked) on (fdb.switch = peer.switcha and fdb.port = peer.porta and fdb.mac = checked.mac and peer.switchb = checked.dns) where fdb.switch = '$vstup' union select fdb.port, fdb.mac, checked.dns, from_unixtime(fdb.time) time from fdb left join checked using (mac) where port not in (select porta from peer where switcha = '$vstup') and fdb.switch = '$vstup' order by time, port, mac" $mysql_prepinace
