#include "log.h"

#include <time.h>

// global variable definition
FILE *logfile;

void log_print_time(void)
{
	time_t t;
	struct tm *tm;
	char str[20];
	t = time(NULL);
	tm = localtime(&t);
	if (tm == NULL) {
		fputs("localtime() failed\n", logfile);
		return;
	}
	if (!strftime(str, sizeof(str), "%F %X", tm)) {
		fputs("strftime() returned 0\n", logfile);
		return;
	}
	fprintf(logfile, "%s ", str);
}

void log_open_logfile(const char *logfilename)
{
	if (logfilename != NULL)
		if ((logfile = fopen(logfilename, "a")) != NULL) {
			log_print_time();
			fprintf(logfile, "logfile %s opened\n", logfilename);
			return;
		} else
			fprintf(stderr, "Failed to open %s, logging to stderr.\n", logfilename);
	else
		fputs("No logfilename given, logging to stderr.\n", stderr);
	logfile = stderr;
}

void log_close_logfile(void)
{
	if (logfile != stderr) {
		log_print_time();
		fputs("closing logfile\n", logfile);
		fclose(logfile);
	}
}

void log_stamp(void)
{
	log_print_time();
}

void log_write(const char *string)
{
	log_stamp();
	fputs(string, logfile);
}
